program wrap;
(* By: me@dledgard.freeserve.co.uk 2nd February 1998
   This is based on a game that I once played on the Commodore Pet Computer
   (Ancient History! It didn't even have a disk drive, just a tape player).
   It originally had an opening sequence where each snake spelled out the 
   word WRAP starting at either end of the screen. If anyone would care to
   write a bit of code for this I would be most grateful.

   You control the snake with the dotted tail, use the cursor arrows to move
   it up, down, left, and right - 'Q' quits. The object is to avoid hitting
   either your tail, or the computer opponent's tail. Whoever hits first
   loses. The computer snake has limited AI to avoid hitting either tail.
   The speed can be changed using the constant below, higher numbers
   = slower, the slower the easier the game becomes. Speed may vary depending
   on processor speed. The pet probably didn't need any delay at all because
   it was so slow, by todays standards. Enjoy. *)

const speed = 600;

type COMPASS = (Up, Down, Left, Right);

var Direction,Direction2: COMPASS;
    i,x1,y1,last_x1,last_y1,x2,y2,last_x2,last_y2: INTEGER;
    Ch: CHAR;
    isQuit, isMove: BOOLEAN;
    SquareFull: array[1..80] of array [1..24] of BOOLEAN;

procedure BlankScreen;
var x,y: INTEGER;
begin
  ClrScr;
  for x:=1 to 80 do
  begin
    for y:=1 to 24 do
    begin
      SquareFull[x,y]:=FALSE;
    end;
  end;
end; (* BlankScreen *)

function isSquareFull(x,y: INTEGER):BOOLEAN;
begin
  if (x<1) then x:=80; if (x>80) then x:=1;
  if (y<1) then y:=24; if (y>24) then y:=1;
  isSquareFull := SquareFull[x,y];
end; (* isSquareFull *)

begin
  BlankScreen;
  Direction:=Right; isQuit:=FALSE;
  x1:=1; y1:=1; last_x1:=x1; last_y1:=y1; SquareFull[x1,y1]:=TRUE;
  GotoXY(x1,y1); Write('>');
  Direction2:=Left;
  x2:=80; y2:=24; last_x2:=x2; last_y2:=y2; SquareFull[x2,y2]:=TRUE;
  GotoXY(x1,y1); Write('<');
  repeat
    if KeyPressed then
    begin
      Read (Kbd,Ch);
      if (ch='q') then isQuit:=TRUE;
      if (Ch=#27) and KeyPressed then
      begin
        read (Kbd,Ch);
        case Ord(Ch) of
          75: Direction:=Left;
          77: Direction:=Right;
          72: Direction:=Up;
          80: Direction:=Down;
        end;
      end;
    end;
    case Direction of
      Left:  x1:=x1-1;
      Right: x1:=x1+1;
      Up:    y1:=y1-1;
      Down:  y1:=y1+1;
    end;
    if (x1<1) then x1:=80; if (x1>80) then x1:=1;
    if (y1<1) then y1:=24; if (y1>24) then y1:=1;
    GotoXY(last_x1,last_y1); Write('.'); last_x1:=x1; last_y1:=y1;
    GotoXY(x1,y1);
    case Direction of
      Left:  Write('<');
      Right: Write('>');
      Up:    Write('^');
      Down:  Write('v');
    end;

    isMove:=FALSE;

    if ((Direction2=Left) AND isSquareFull(x2-2,y2)) OR
    ((Direction2=Right) AND isSquareFull(x2+2,y2)) then
    begin
           if (NOT isSquareFull(x2,y2-2)) AND (NOT isSquareFull(x2,y2-1))
           then begin
             Direction2:=Up; isMove:=True;
           end
      else if (NOT isSquareFull(x2,y2+2)) AND (NOT isSquareFull(x2,y2+1))
           then begin
             Direction2:=Down; isMove:=True;
           end
    end;

    if (NOT isMove) AND ((Direction2=Up) AND isSquareFull(x2,y2-2)) OR
    ((Direction2=Down) AND isSquareFull(x2,y2+2)) then
    begin
           if (NOT isSquareFull(x2-2,y2)) AND (NOT isSquareFull(x2-1,y2))
           then begin
             Direction2:=Left; isMove:=True;
           end
      else if (NOT isSquareFull(x2+2,y2)) AND (NOT isSquareFull(x2+1,y2))
           then begin
             Direction2:=Right; isMove:=True;
           end;
    end;

    if (NOT isMove) AND ((Direction2=Left) AND isSquareFull(x2-1,y2)) OR
    ((Direction2=Right) AND isSquareFull(x2+1,y2)) then
    begin
      isMove:=TRUE;
           if NOT isSquareFull(x2,y2-1) then Direction2:=Up
      else if NOT isSquareFull(x2,y2+1) then Direction2:=Down;
    end;

    if (NOT isMove) AND ((Direction2=Up) AND isSquareFull(x2,y2-1)) OR
    ((Direction2=Down) AND isSquareFull(x2,y2+1)) then
    begin
      isMove:=TRUE;
           if NOT isSquareFull(x2-1,y2) then Direction2:=Left
      else if NOT isSquareFull(x2+1,y2) then Direction2:=Right;
    end;

    case Direction2 of
      Left:  x2:=x2-1;
      Right: x2:=x2+1;
      Up:    y2:=y2-1;
      Down:  y2:=y2+1;
    end;
    if (x2<1) then x2:=80; if (x2>80) then x2:=1;
    if (y2<1) then y2:=24; if (y2>24) then y2:=1;
    GotoXY(last_x2,last_y2); Write('*'); last_x2:=x2; last_y2:=y2;
    GotoXY(x2,y2);
    case Direction2 of
      Left:  Write('<');
      Right: Write('>');
      Up:    Write('^');
      Down:  Write('v');
    end;

    delay (speed);
    if SquareFull[x1,y1] OR SquareFull[x2,y2] then
    begin
      Write(Chr(7));
      isQuit:=TRUE;
      repeat until KeyPressed;
    end;
    SquareFull[x1,y1]:=TRUE;
    SquareFull[x2,y2]:=TRUE;
  until isQuit;
end.
